(function ($, Drupal, once) {


    // JS with no Ajax repeate
    $(document).find(".view-concentrations-grid .views-row").each(function(){
        $(this).addClass('old-search-card');
    });

    let motionQuery = matchMedia('(prefers-reduced-motion)');
    function reducedMotionCheck() {
        setTimeout(function(){
            if ( motionQuery.matches ) {
                $(".videoBlock video").removeAttr("autoplay");
                $("#pauseButton img").attr('src', '/themes/custom/cfmg/assets/images/play.png');
            }
            else {
                // code to run if no preference is true
            }
        }, 10);
    }
    reducedMotionCheck();
    motionQuery.addListener(reducedMotionCheck);


    /**
     *
     * @type {{attach: Drupal.behaviors.AdditionalJS.attach}}
     */
    Drupal.behaviors.AccessibilityJS = {
        attach: function (context, settings) {

            //bullet focus
            $(".slidingCards .slick-dots li > button", context).on("keydown", function(e){
                if(e.keyCode == 13 || e.keyCode == 32){
                    setTimeout(function(){
                        $(".slidingCards .slidingCard.slick-active .face.front button.rightplus").focus();
                    },100);
                }
            });

            // Header Main Menu
            $(context).on("keydown", ".menuButton", function(e){
                if(e.keyCode == 32){
                    e.preventDefault();
                    $(".menuButton").trigger("click").focus();
                }
            });
            $(context).on("keydown", ".region-header-menu a", function(e){
                if(e.keyCode == 27){
                    e.preventDefault();
                    $(".menuButton").trigger("click").focus();
                }
            });
            $(context).on("keydown", ".socialRow > a:last-child", function(e){
                if(e.keyCode == 9){
                    if(!e.shiftKey) {
                        e.preventDefault();
                        $(".menuButton").focus();
                    }
                }
            });


            $('section.layout-hero-content, section.layout-content-top, main, footer').on('keydown', function(e){
                if (e.keyCode == 9 && !e.shiftKey) {
                    if($('body').hasClass('open-megamenu')) {
                        e.preventDefault();
                    }
                }
            });


            $(context).on("keydown", ".menuExpand", function(e){
                if(e.keyCode == 13 || e.keyCode == 32){
                    e.preventDefault();
                    $(".menuExpand:not(.focused)").removeClass("focused");
                    $(this).toggleClass("focused");
                    if($(this).hasClass("focused")){
                        $(this).attr("aria-expanded", "true");
                        $(".midCol .subMenu").removeClass("active");
                        $(".midCol ."+$(this).attr("data-submenu")).addClass("active").children(".subMenuCloseButton").focus();
                    } else {
                        $(".midCol ."+$(this).attr("data-submenu")).removeClass("active");
                        $(this).attr("aria-expanded", "false");
                    }
                }
            });

            $(context).on("keydown", ".menuExpand.focused", function(e){
                if(e.keyCode == 9){
                    if(!e.shiftKey) {
                        e.preventDefault();
                        $(".midCol .subMenu.active a.first").focus();
                    }
                }
                if(event.shiftKey && event.keyCode == 9) {
                    e.preventDefault();
                    $(".midCol .subMenu.active .second-level-menus >a:last-child").focus();
                }
            });


            // Feature 50/50 with Dropdown Module
            $(".selectdiv.fullWidth").find("select").on("change", function(){
                $(this).children("option").attr("aria-selected", "false");
                $(this).children("option[value='"+$(this).val()+"']").attr("aria-selected", "true");
            });

            // Carousel
            $(".slidingCards .slick-dots li > button").attr("tabindex", "0");
            $(once('AccessibilityJS', "button.rightplus", context, ".slidingCard")).on("keydown", function(e){
                if(e.keyCode == 13 || e.keyCode == 32){
                    setTimeout(function(){
                        if($(".slidingCards .slick-active.slidingCard .face.back").find("h4 > a").length > 0){
                            $(".slidingCards .slick-active.slidingCard .face.back").find("h4 > a").focus();
                        } else {
                            $(".slidingCards .slick-active.slidingCard .face.back").find("button.faceback-close").focus();
                        }
                    }, 100);
                }
                if(e.keyCode == 9){
                    if(!e.shiftKey) {
                        e.preventDefault();
                        $(".slidingCards .arrowRow > a.al-prevArrow").focus();
                    }
                }
            });
            $(context).on("keydown", ".al-arrowRow .al-prevArrow", function(e) {
                if (e.keyCode == 32 || e.keyCode == 13) {
                    $(this).trigger("click");
                }
            });
            $(context).on("keydown", ".al-arrowRow .al-nextArrow", function(e) {
                if (e.keyCode == 32 || e.keyCode == 13) {
                    $(this).trigger("click");
                }
            });

            $(".slidingCards .face.back a", context).attr("tabindex", "-1");
            $(".slidingCards .face.back button", context).attr("tabindex", "-1");
            $(once('AccessibilityJS', "button.rightplus", context, ".slidingCard")).on("keydown", function(e){
                if(e.keyCode == 13 || e.keyCode == 32){
                    setTimeout(function(){
                        $(".slidingCards .slick-active.slidingCard .face.back").find("h4 > a").focus();
                        $(".slidingCards .slick-active.slidingCard .face.back button").attr("tabindex", "0");
                    }, 100);
                }
                if(e.keyCode == 9){
                    if(!e.shiftKey) {
                        e.preventDefault();
                        $(".slidingCards .arrowRow > a.al-prevArrow").focus();
                    }
                }
            });

            $(once('AccessibilityJS', '.slidingCards a.al-prevArrow', context)).on("keydown", function(e){
                if(e.shiftKey && e.keyCode == 9){
                    e.preventDefault();
                    $(".slidingCard.slick-active .rightplus").focus();
                }
            });

            // Searchable Cards
            $(".searchableCard .face.back").find("h4 > a").attr("tabindex", "-1");
            $(".searchableCard .face.back button").attr("tabindex", "-1");
            $(".searchableCard").find("button.bottomRightPlus", context).on("keydown", function(e){
                if(e.keyCode == 13 || e.keyCode == 32){
                    setTimeout(function(){
                        $(".searchableCard.flipped .face.back").find("h4 > a").attr("tabindex", "0").focus();
                        $(".searchableCard.flipped .face.back button").attr("tabindex", "0");
                    }, 100);
                }
            });
            $(once('AccessibilityJS', context)).on("keydown", '.searchableCard.flipped .face.back button', function(e){
                if(e.keyCode == 13 || e.keyCode == 32){
                    e.preventDefault();
                    $(this).parents(".searchableCard").removeClass("flipped");
                    $(this).parents(".searchableCard").children().children("button.bottomRightPlus").focus();
                    $(".searchableCard").not(".flipped").find(".face.back h4 > a").attr("tabindex", "-1");
                    $(".searchableCard").not(".flipped").find(".face.back button").attr("tabindex", "-1");
                }
                if(e.keyCode == 9) {
                    e.preventDefault();
                    if (!e.shiftKey) {
                        setTimeout(function(){
                            $(".searchableCard.flipped .face.back h4 > a").focus();
                        }, 100);
                    }
                }
            });

            $(once('weberAjaxViews', document)).ajaxComplete(function (event, xhr, settings) {
                $(document).find(".view-concentrations-grid .views-row").not(".old-search-card").each(function(){
                    $(this).addClass('new_search_card');
                });
                setTimeout(function (){
                    $(document).find(".view-concentrations-grid .views-row.new_search_card:first .searchableCard button.bottomRightPlus").focus();
                    $(document).find(".view-concentrations-grid .new_search_card.views-row").addClass("old-search-card").removeClass("new_search_card");
                }, 1000);
            });
            // $(".slidingCards .slick-dots li:last-child > button").on("keydown", function (e){
            //     if(e.keyCode == 9){
            //         if(!e.shiftKey) {
            //             $(this).parents(".paragraph--type--carousel").parents().next().find("a").focus();
            //         }
            //     }
            // });


            $(document).mouseup(function (e) {
                var container = $(".search-menu-block .form-type-textfield input, .searchParent");

                // if the target of the click isn't the container nor a descendant of the container
                if (!container.is(e.target) && container.has(e.target).length === 0) {
                    $(".searchParent .search[aria-expanded='true']").trigger('click');
                }
            });

            //
            $(".company-brand .logo a").on("focus", function () {
                $('.logoDropDown__menu').addClass('active focus-in');
            });
            $(".logoDropDown__menu a").on("keydown", function (e) {
                if (e.keyCode == 9) {
                    if(!e.shiftKey) {
                        $('.logoDropDown__menu').removeClass('active focus-in');
                    }
                }
            });


            // Search Accessibility
            $(context).on("keydown", ".searchParent .search[aria-expanded='false']", function (e) {
                if (e.keyCode == 13) {
                    setTimeout(function () {
                        $("#views-exposed-form-view-search-page-1").find(".form-type-textfield input").focus();
                    }, 500);
                }
                // if (e.which == 9) {
                //     if (!e.shiftKey) {
                //         $(".searchParent .search[aria-expanded='true']").trigger('click');
                //         setTimeout(function () {
                //             $(".searchParent .search").next(".menuButton").focus();
                //         }, 100);
                //         $("#views-exposed-form-view-search-page-1").find(".form-type-textfield input").focus();
                //     }
                // }
            });
            $(context).on("keydown", ".searchParent .search[aria-expanded='false']", function (e) {
                if (e.keyCode == 32) {
                    setTimeout(function () {
                        $(".search").trigger("click");
                        $("#views-exposed-form-view-search-page-1").find(".form-type-textfield input").focus();
                    }, 500);
                }
            });
            $(context).on("keydown", ".searchParent .search[aria-expanded='true']", function(e){
                e.preventDefault();
                if (e.keyCode == 13 || e.keyCode == 32) {
                    $(this).trigger("click");
                }
                if (e.keyCode == 9) {
                    if (!e.shiftKey) {
                        setTimeout(function () {
                            $("#views-exposed-form-view-search-page-1").find(".form-type-textfield input").focus();
                        }, 10);
                    }
                }
            });

            var focused = document.activeElement;

            $("#views-exposed-form-view-search-page-1", context).find(".form-type-textfield input").on("keydown", function (e) {
                if (e.keyCode == 27) {
                    e.preventDefault();
                    $("a.search").click().focus();
                }
                if (e.keyCode == 9) {
                    if(!e.shiftKey) {
                        e.preventDefault();
                        $(".searchParent a.search").focus();
                    }
                }
            });

            $(document).ready( function () {
                setTimeout(function(){
                    $('.menu  a').attr("tabindex", "-1");
                    $('.menu  button').attr("tabindex", "-1");
                },100);
            });

            $(".subMenu").find(".subMenuCloseButton", context).on("keydown", function (e){
                if ($(window).width() < 991) {
                    if(e.keyCode == 13 || e.keyCode == 32) {
                        $(this).trigger("click");
                        setTimeout(function () {
                            $(".focused.menuExpand").focus().removeClass("focused").attr("aria-expanded", 'false');
                        }, 100);
                    }
                    if(e.keyCode == 9 && e.shiftKey) {
                        setTimeout(function () {
                            $(".subMenu.active").find(".second-level-menus > a:last-child").focus();
                        }, 10);
                    }
                }
            });
            $(".subMenu").find(".second-level-menus > a:last-child", context).on("keydown", function (e){
                if ($(window).width() < 991) {
                    if(e.keyCode == 9 && !e.shiftKey) {
                        setTimeout(function () {
                            $(".subMenu.active").find('.subMenuCloseButton').focus();
                        }, 10);
                    }
                }else{
                    if(e.keyCode == 9 && !e.shiftKey) {
                        setTimeout(function () {
                            $(".focused.menuExpand").focus();
                        }, 10);
                    }
                }
            });
            $(".subMenu").find(".second-level-menus > a:first-child", context).on("keydown", function (e){
                if ($(window).width() < 991) {
                    if(e.keyCode == 9 && e.shiftKey) {
                        setTimeout(function () {
                            $(".subMenu.active").find('.subMenuCloseButton').focus();
                        }, 1);
                    }
                }else {
                    if(e.keyCode == 9 && e.shiftKey) {
                        setTimeout(function () {
                            $(".focused.menuExpand").focus();
                        }, 1);
                    }
                }
            });
            $(".firstCol").find(".top-level-menus > span:last-child a > button", context).on("keydown", function (e){
                if ($(window).width() < 991) {
                    if(e.keyCode == 9) {
                        setTimeout(function () {
                            $(".field--type-text-with-summary").find('.rightColLinks a:first-child').focus();
                        }, 1000);
                    }
                }else{
                    if(e.keyCode == 9) {
                        setTimeout(function () {
                            $(this).not(".focused").find('.rightColLinks a:first-child').focus();
                        }, 1000);
                    }
                }
            });
            $(".field--type-text-with-summary").find('.rightColLinks a:first-child').on("keydown", function (e){
                if ($(window).width() < 991) {
                    if(e.shiftKey && e.keyCode == 9){
                        e.preventDefault();
                        $(".firstCol").find(".top-level-menus > a:last-child").focus();
                    }
                }
            });
        }
    };

})(jQuery, Drupal, once);
